/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon

import android.content.ActivityNotFoundException
import android.content.Intent
import android.net.Uri
import android.provider.Browser
import android.text.TextUtils
import android.util.Log
import android.view.View

class LinkResolverDef : LinkResolver {
    override fun resolve(view: View, link: String) {
        val uri = parseLink(link)
        val context = view.context
        val intent = Intent(Intent.ACTION_VIEW, uri)
        intent.putExtra(Browser.EXTRA_APPLICATION_ID, context.packageName)
        try {
            context.startActivity(intent)
        } catch (e: ActivityNotFoundException) {
            if (BuildConfig.DEBUG)
                Log.w("LinkResolverDef", "Actvity was not found for the link: '$link'")
        }
    }

    companion object {
        // @since 4.3.0
        private const val DEFAULT_SCHEME = "https"

        /** @since 4.3.0 */
        private fun parseLink(link: String): Uri {
            val uri = Uri.parse(link)
            return if (TextUtils.isEmpty(uri.scheme)) {
                uri.buildUpon().scheme(DEFAULT_SCHEME).build()
            } else uri
        }
    }
}
