/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon

/** @since 4.1.1 */
internal abstract class MarkwonVisitorFactory {
    abstract fun create(): MarkwonVisitor

    companion object {
        @JvmStatic
        fun create(
            builder: MarkwonVisitor.Builder,
            configuration: MarkwonConfiguration
        ): MarkwonVisitorFactory {
            return object : MarkwonVisitorFactory() {
                override fun create(): MarkwonVisitor {
                    return builder.build(configuration, RenderPropsImpl())
                }
            }
        }
    }
}
