/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import java.util.HashMap;
import java.util.Map;

/**
 * @since 3.0.0
 */
class RenderPropsImpl implements RenderProps {

  private final Map<Prop, Object> values = new HashMap<>(3);

  @Nullable
  @Override
  public <T> T get(@NonNull Prop<T> prop) {
    //noinspection unchecked
    return (T) values.get(prop);
  }

  @NonNull
  @Override
  public <T> T get(@NonNull Prop<T> prop, @NonNull T defValue) {
    Object value = values.get(prop);
    if (value != null) {
      //noinspection unchecked
      return (T) value;
    }
    return defValue;
  }

  @Override
  public <T> void set(@NonNull Prop<T> prop, @Nullable T value) {
    if (value == null) {
      values.remove(prop);
    } else {
      values.put(prop, value);
    }
  }

  @Override
  public <T> void clear(@NonNull Prop<T> prop) {
    values.remove(prop);
  }

  @Override
  public void clearAll() {
    values.clear();
  }
}
