/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon

import org.commonmark.node.SoftLineBreak

/** @since 4.3.0 */
class SoftBreakAddsNewLinePlugin : AbstractMarkwonPlugin() {
    override fun configureVisitor(builder: MarkwonVisitor.Builder) {
        builder.on(SoftLineBreak::class.java) { visitor: MarkwonVisitor, _: SoftLineBreak ->
            visitor.ensureNewLine()
        }
    }

    companion object {
        fun create(): SoftBreakAddsNewLinePlugin {
            return SoftBreakAddsNewLinePlugin()
        }
    }
}
