/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.core

import io.noties.markwon.Prop

/** @since 3.0.0 */
object CoreProps {
    @JvmField val LIST_ITEM_TYPE = Prop.of<ListItemType>("list-item-type")
    @JvmField val BULLET_LIST_ITEM_LEVEL = Prop.of<Int>("bullet-list-item-level")
    @JvmField val ORDERED_LIST_ITEM_NUMBER = Prop.of<Int>("ordered-list-item-number")
    @JvmField val HEADING_LEVEL = Prop.of<Int>("heading-level")
    @JvmField val LINK_DESTINATION = Prop.of<String>("link-destination")
    @JvmField val PARAGRAPH_IS_IN_TIGHT_LIST = Prop.of<Boolean>("paragraph-is-in-tight-list")

    /** @since 4.1.1 */
    @JvmField val CODE_BLOCK_INFO = Prop.of<String>("code-block-info")

    enum class ListItemType {
        BULLET,
        ORDERED
    }
}
