/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.core.factory

import io.noties.markwon.MarkwonConfiguration
import io.noties.markwon.RenderProps
import io.noties.markwon.SpanFactory
import io.noties.markwon.core.CoreProps
import io.noties.markwon.core.spans.BulletListItemSpan
import io.noties.markwon.core.spans.OrderedListItemSpan

class ListItemSpanFactory : SpanFactory {
    override fun getSpans(configuration: MarkwonConfiguration, props: RenderProps): Any {

        // type of list item
        // bullet : level
        // ordered: number
        val spans: Any
        spans =
            if (CoreProps.ListItemType.BULLET == CoreProps.LIST_ITEM_TYPE.require(props)) {
                BulletListItemSpan(
                    configuration.theme(), CoreProps.BULLET_LIST_ITEM_LEVEL.require(props))
            } else {

                // todo| in order to provide real RTL experience there must be a way to provide this
                // string
                val number =
                    CoreProps.ORDERED_LIST_ITEM_NUMBER.require(props).toString() + "." + '\u00a0'
                OrderedListItemSpan(configuration.theme(), number)
            }
        return spans
    }
}
