/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.core.spans

import android.text.TextPaint
import android.text.style.MetricAffectingSpan
import io.noties.markwon.core.MarkwonTheme

/** @since 3.0.0 split inline and block spans */
class CodeSpan(private val theme: MarkwonTheme) : MetricAffectingSpan() {
    override fun updateMeasureState(p: TextPaint) {
        apply(p)
    }

    override fun updateDrawState(ds: TextPaint) {
        apply(ds)
        ds.bgColor = theme.getCodeBackgroundColor(ds)
    }

    private fun apply(p: TextPaint) {
        theme.applyCodeTextStyle(p)
    }
}
