/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.core.spans

import android.text.TextPaint
import android.text.style.URLSpan
import android.view.View
import io.noties.markwon.LinkResolver
import io.noties.markwon.core.MarkwonTheme

class LinkSpan(
    private val theme: MarkwonTheme,
    /** @since 4.2.0 */
    val link: String,
    private val resolver: LinkResolver
) : URLSpan(link) {
    override fun onClick(widget: View) {
        resolver.resolve(widget, link)
    }

    override fun updateDrawState(ds: TextPaint) {
        theme.applyLinkStyle(ds)
    }
}
