/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.core.spans

import android.graphics.Paint
import android.graphics.Rect
import android.graphics.RectF

internal object ObjectsPool {
    // maybe it's premature optimization, but as all the drawing is done in one thread
    // and we apply needed values before actual drawing it's (I assume) safe to reuse some
    // frequently used objects
    // if one of the spans need some really specific handling for Paint object (like colorFilters,
    // masks, etc)
    // it should instantiate own instance of it
    private val RECT = Rect()
    private val RECT_F = RectF()
    private val PAINT = Paint(Paint.ANTI_ALIAS_FLAG)

    fun rect(): Rect {
        return RECT
    }

    fun rectF(): RectF {
        return RECT_F
    }

    fun paint(): Paint {
        return PAINT
    }
}
