/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html

import io.noties.markwon.MarkwonVisitor

abstract class TagHandler {
    abstract fun handle(visitor: MarkwonVisitor, renderer: MarkwonHtmlRenderer, tag: HtmlTag)

    /** @since 4.0.0 */
    abstract fun supportedTags(): Collection<String?>

    companion object {
        @JvmStatic
        protected fun visitChildren(
            visitor: MarkwonVisitor,
            renderer: MarkwonHtmlRenderer,
            block: HtmlTag.Block
        ) {
            var handler: TagHandler?
            for (child in block.children()) {
                if (!child.isClosed) {
                    continue
                }
                handler = renderer.tagHandler(child.name())
                if (handler != null) {
                    handler.handle(visitor, renderer, child)
                } else {
                    visitChildren(visitor, renderer, child)
                }
            }
        }
    }
}
