/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html

import io.noties.markwon.MarkwonVisitor

/** @since 4.0.0 */
class TagHandlerNoOp internal constructor(private val tags: Collection<String?>) : TagHandler() {
    override fun handle(visitor: MarkwonVisitor, renderer: MarkwonHtmlRenderer, tag: HtmlTag) {
        // no op
    }

    override fun supportedTags(): Collection<String?> {
        return tags
    }

    companion object {
        fun create(tag: String): TagHandlerNoOp {
            return TagHandlerNoOp(setOf(tag))
        }

        fun create(vararg tags: String): TagHandlerNoOp {
            return TagHandlerNoOp(listOf(*tags))
        }
    }
}
