/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.jsoup.nodes

import org.commonmark.internal.util.Html5Entities

object CommonMarkEntities {
    private var COMMONMARK_NAMED_ENTITIES: Map<String?, String?>? = null

    init {
        var map: Map<String?, String?>
        try {
            val field = Html5Entities::class.java.getDeclaredField("NAMED_CHARACTER_REFERENCES")
            field.isAccessible = true
            map = field[null] as Map<String?, String?>
        } catch (t: Throwable) {
            map = emptyMap<String?, String>()
            t.printStackTrace(System.out)
        }
        COMMONMARK_NAMED_ENTITIES = map
    }

    @JvmStatic
    fun isNamedEntity(name: String): Boolean {
        return COMMONMARK_NAMED_ENTITIES!!.containsKey(name)
    }

    @JvmStatic
    fun codepointsForName(name: String, codepoints: IntArray): Int {
        val value = COMMONMARK_NAMED_ENTITIES!![name]
        if (value != null) {
            val length = value.length
            codepoints[0] = value[0].code
            if (length != 1) {
                codepoints[1] = value[1].code
            }
            return length
        }
        return 0
    }
}
