/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.jsoup.parser

/**
 * A container for ParseErrors.
 *
 * @author Jonathan Hedley
 */
class ParseErrorList internal constructor(initialCapacity: Int, val maxSize: Int) :
    ArrayList<ParseError?>(initialCapacity) {

    fun canAddError(): Boolean {
        return size < maxSize
    }

    companion object {
        private const val INITIAL_CAPACITY = 16

        @JvmStatic
        fun noTracking(): ParseErrorList {
            return ParseErrorList(0, 0)
        }

        fun tracking(maxSize: Int): ParseErrorList {
            return ParseErrorList(INITIAL_CAPACITY, maxSize)
        }
    }
}
