/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.span

import android.text.TextPaint
import android.text.style.MetricAffectingSpan
import io.noties.markwon.html.HtmlPlugin

class SubScriptSpan : MetricAffectingSpan() {
    override fun updateDrawState(tp: TextPaint) {
        apply(tp)
    }

    override fun updateMeasureState(tp: TextPaint) {
        apply(tp)
    }

    private fun apply(paint: TextPaint) {
        paint.textSize = paint.textSize * HtmlPlugin.SCRIPT_DEF_TEXT_SIZE_RATIO
        paint.baselineShift -= (paint.ascent() / 2).toInt()
    }
}
