/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.tag

import io.noties.markwon.MarkwonVisitor
import io.noties.markwon.SpannableBuilder
import io.noties.markwon.html.HtmlTag
import io.noties.markwon.html.MarkwonHtmlRenderer
import io.noties.markwon.html.TagHandler
import org.commonmark.node.BlockQuote

class BlockquoteHandler : TagHandler() {
    override fun handle(visitor: MarkwonVisitor, renderer: MarkwonHtmlRenderer, tag: HtmlTag) {
        if (tag.isBlock) {
            visitChildren(visitor, renderer, tag.asBlock)
        }
        val configuration = visitor.configuration()
        val factory = configuration.spansFactory()[BlockQuote::class.java]
        if (factory != null) {
            SpannableBuilder.setSpans(
                visitor.builder(),
                factory.getSpans(configuration, visitor.renderProps()),
                tag.start(),
                tag.end())
        }
    }

    override fun supportedTags(): Collection<String> {
        return setOf("blockquote")
    }
}
