/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.tag

import io.noties.markwon.MarkwonConfiguration
import io.noties.markwon.RenderProps
import io.noties.markwon.html.HtmlTag
import org.commonmark.node.Emphasis

class EmphasisHandler : SimpleTagHandler() {
    override fun getSpans(
        configuration: MarkwonConfiguration,
        renderProps: RenderProps,
        tag: HtmlTag
    ): Any? {
        val spanFactory = configuration.spansFactory()[Emphasis::class.java] ?: return null
        return spanFactory.getSpans(configuration, renderProps)
    }

    override fun supportedTags(): Collection<String> {
        return mutableListOf("i", "em", "cite", "dfn")
    }
}
