/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.tag

import io.noties.markwon.MarkwonConfiguration
import io.noties.markwon.RenderProps
import io.noties.markwon.core.CoreProps
import io.noties.markwon.html.HtmlTag
import org.commonmark.node.Heading

class HeadingHandler : SimpleTagHandler() {
    override fun getSpans(
        configuration: MarkwonConfiguration,
        renderProps: RenderProps,
        tag: HtmlTag
    ): Any? {
        val factory = configuration.spansFactory()[Heading::class.java] ?: return null
        val level: Int =
            try {
                tag.name().substring(1).toInt()
            } catch (e: NumberFormatException) {
                e.printStackTrace()
                0
            }
        if (level < 1 || level > 6) {
            return null
        }
        CoreProps.HEADING_LEVEL[renderProps] = level
        return factory.getSpans(configuration, renderProps)
    }

    override fun supportedTags(): Collection<String> {
        return mutableListOf("h1", "h2", "h3", "h4", "h5", "h6")
    }
}
