/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.html.tag

import android.text.TextUtils
import io.noties.markwon.MarkwonConfiguration
import io.noties.markwon.RenderProps
import io.noties.markwon.core.CoreProps
import io.noties.markwon.html.HtmlTag
import org.commonmark.node.Link

class LinkHandler : SimpleTagHandler() {
    override fun getSpans(
        configuration: MarkwonConfiguration,
        renderProps: RenderProps,
        tag: HtmlTag
    ): Any? {
        val destination = tag.attributes()["href"]
        if (!TextUtils.isEmpty(destination)) {
            val spanFactory = configuration.spansFactory()[Link::class.java]
            if (spanFactory != null) {
                CoreProps.LINK_DESTINATION[renderProps] = destination
                return spanFactory.getSpans(configuration, renderProps)
            }
        }
        return null
    }

    override fun supportedTags(): Collection<String> {
        return setOf("a")
    }
}
