/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image;

import android.graphics.drawable.Drawable;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

public abstract class AsyncDrawableLoader {

  /**
   * @since 3.0.0
   */
  @NonNull
  public static AsyncDrawableLoader noOp() {
    return new AsyncDrawableLoaderNoOp();
  }

  /**
   * @since 4.0.0
   */
  public abstract void load(@NonNull AsyncDrawable drawable);

  /**
   * @since 4.0.0
   */
  public abstract void cancel(@NonNull AsyncDrawable drawable);

  @Nullable
  public abstract Drawable placeholder(@NonNull AsyncDrawable drawable);
}
