/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image;

import androidx.annotation.Nullable;

/**
 * @since 1.0.1
 */
@SuppressWarnings("WeakerAccess")
public class ImageSize {

  public final Dimension width;
  public final Dimension height;

  public ImageSize(@Nullable Dimension width, @Nullable Dimension height) {
    this.width = width;
    this.height = height;
  }

  @Override
  public String toString() {
    return "ImageSize{" + "width=" + width + ", height=" + height + '}';
  }

  public static class Dimension {

    public final float value;
    public final String unit;

    public Dimension(float value, @Nullable String unit) {
      this.value = value;
      this.unit = unit;
    }

    @Override
    public String toString() {
      return "Dimension{" + "value=" + value + ", unit='" + unit + '\'' + '}';
    }
  }
}
