/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image;

import android.net.Uri;
import androidx.annotation.NonNull;
import java.util.Collection;

/**
 * @since 3.0.0
 */
public abstract class SchemeHandler {

  /**
   * Changes since 4.0.0:
   *
   * <ul>
   *   <li>Returns `non-null` image-item
   * </ul>
   *
   * @see ImageItem#withResult(android.graphics.drawable.Drawable)
   * @see ImageItem#withDecodingNeeded(String, java.io.InputStream)
   */
  @NonNull
  public abstract ImageItem handle(@NonNull String raw, @NonNull Uri uri);

  /**
   * @since 4.0.0
   */
  @NonNull
  public abstract Collection<String> supportedSchemes();
}
