/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image.data

class DataUri(
    private val contentType: String?,
    private val base64: Boolean,
    private val data: String?
) {
    fun contentType(): String? {
        return contentType
    }

    fun base64(): Boolean {
        return base64
    }

    fun data(): String? {
        return data
    }

    override fun toString(): String {
        return "DataUri{" +
            "contentType='" +
            contentType +
            '\'' +
            ", base64=" +
            base64 +
            ", data='" +
            data +
            '\'' +
            '}'
    }

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || javaClass != other.javaClass) return false
        val dataUri = other as DataUri
        if (base64 != dataUri.base64) return false
        return if (contentType != dataUri.contentType) false else data == dataUri.data
    }

    override fun hashCode(): Int {
        var result = contentType?.hashCode() ?: 0
        result = 31 * result + if (base64) 1 else 0
        result = 31 * result + (data?.hashCode() ?: 0)
        return result
    }
}
