/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image.destination

import java.net.MalformedURLException
import java.net.URL

/** @since 4.4.0 */
class ImageDestinationProcessorRelativeToAbsolute : ImageDestinationProcessor {
    private val base: URL?

    constructor(base: String) {
        this.base = obtain(base)
    }

    constructor(base: URL) {
        this.base = base
    }

    override fun process(destination: String): String {
        var out = destination
        if (base != null) {
            try {
                val u = URL(base, destination)
                out = u.toString()
            } catch (e: MalformedURLException) {
                e.printStackTrace()
            }
        }
        return out
    }

    companion object {
        fun create(base: String): ImageDestinationProcessorRelativeToAbsolute {
            return ImageDestinationProcessorRelativeToAbsolute(base)
        }

        fun create(base: URL): ImageDestinationProcessorRelativeToAbsolute {
            return ImageDestinationProcessorRelativeToAbsolute(base)
        }

        private fun obtain(base: String): URL? {
            return try {
                URL(base)
            } catch (e: MalformedURLException) {
                e.printStackTrace()
                null
            }
        }
    }
}
