/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.image.svg

import android.util.Log
import io.noties.markwon.BuildConfig

/** @since 4.0.0 */
object SvgSupport {
    private var HAS_SVG = false

    init {
        val result: Boolean =
            try {
                Class.forName("com.caverock.androidsvg.SVG")
                true
            } catch (t: Throwable) {
                // @since 4.1.1 instead of printing full stacktrace of the exception,
                // just print a warning to the console
                if (BuildConfig.DEBUG) Log.w("MarkwonImagesPlugin", missingMessage())
                false
            }
        HAS_SVG = result
    }

    @JvmStatic
    fun hasSvgSupport(): Boolean {
        return HAS_SVG
    }

    /** @since 4.1.1 */
    fun missingMessage(): String {
        return "`com.caverock:androidsvg:*` dependency is missing, " +
            "please add to your project explicitly if you wish to use SVG media-decoder"
    }
}
