/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.utils

import android.graphics.Color
import androidx.annotation.ColorInt
import androidx.annotation.FloatRange
import androidx.annotation.IntRange

object ColorUtils {
    @JvmStatic
    @ColorInt
    fun applyAlpha(@ColorInt color: Int, @IntRange(from = 0, to = 255) alpha: Int): Int {
        return color and 0x00FFFFFF or (alpha shl 24)
    }

    // blend two colors w/ specified ratio, resulting color won't have alpha channel
    @ColorInt
    fun blend(
        @ColorInt foreground: Int,
        @ColorInt background: Int,
        @FloatRange(from = 0.0, to = 1.0) ratio: Float
    ): Int {
        return Color.rgb(
            ((1f - ratio) * Color.red(foreground) + ratio * Color.red(background)).toInt(),
            ((1f - ratio) * Color.green(foreground) + ratio * Color.green(background)).toInt(),
            ((1f - ratio) * Color.blue(foreground) + ratio * Color.blue(background)).toInt())
    }
}
