/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.utils;

import android.text.Spannable;
import android.text.SpannableString;
import androidx.annotation.NonNull;

/**
 * Utility SpannableFactory that re-uses Spannable instance between multiple `TextView#setText`
 * calls.
 *
 * @since 3.0.0
 */
public class NoCopySpannableFactory extends Spannable.Factory {

  @NonNull
  public static NoCopySpannableFactory getInstance() {
    return Holder.INSTANCE;
  }

  @Override
  public Spannable newSpannable(CharSequence source) {
    return source instanceof Spannable ? (Spannable) source : new SpannableString(source);
  }

  static class Holder {
    private static final NoCopySpannableFactory INSTANCE = new NoCopySpannableFactory();
  }
}
