/*
 * Copyright (c) 田梓萱[小草林] 2021-2024.
 * All Rights Reserved.
 * All codes are protected by China's regulations on the protection of computer software, and infringement must be investigated.
 * 版权所有 (c) 田梓萱[小草林] 2021-2024.
 * 所有代码均受中国《计算机软件保护条例》保护，侵权必究.
 */
package io.noties.markwon.utils

import android.graphics.Canvas
import android.text.Spanned
import io.noties.markwon.core.spans.TextLayoutSpan.Companion.layoutOf
import io.noties.markwon.core.spans.TextViewSpan.Companion.textViewOf

/** @since 4.4.0 */
object SpanUtils {
    @JvmStatic
    fun width(canvas: Canvas, cs: CharSequence): Int {
        // Layout
        // TextView
        // canvas
        if (cs is Spanned) {

            // if we are displayed with layout information -> use it
            val layout = layoutOf(cs)
            if (layout != null) {
                return layout.width
            }

            // if we have TextView -> obtain width from it (exclude padding)
            val textView = textViewOf(cs)
            if (textView != null) {
                return textView.width - textView.paddingLeft - textView.paddingRight
            }
        }

        // else just use canvas width
        return canvas.width
    }
}
